#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;
#include common_scripts\utility;
#include braxi\_common;
init( )
{
	self thread plugins\stats::Start();
	self thread plugins\Challenge::Challenge();
	self thread Health();
	self thread OnDeath();
	self thread OnDisconnect();
	self thread OnSpec();
	self thread OnSpawnedAgain();
}
OnSpawnedAgain()
{
	self waittill( "spawned_player" );
	self thread init();
}
OnDeath()
{
	wait 5;
	self waittill("death");
	if(isDefined(self.hud_health))
	{
		self.hud_health thread killhud();
	}
	if(isDefined(self.hud_playermodstats))
	{
		self.hud_playermodstats thread killhud();
	}
}
OnDisconnect()
{
	self waittill("disconnect");
	if(isDefined(self.hud_health))
	{
		self.hud_health thread killhud();
	}
	if(isDefined(self.hud_playermodstats))
	{
		self.hud_playermodstats thread killhud();
	}
}
OnSpec()
{
	self waittill("joined_spectators");
	if(isDefined(self.hud_health))
	{
		self.hud_health thread killhud();
	}
	if(isDefined(self.hud_playermodstats))
	{
		self.hud_playermodstats thread killhud();
	}
	
}
Health()
{
	self endon("disconnect");
	self endon("joined_spectators");
	
	if(isdefined(self.hud_health))
		self.hud_health destroy();

	self.hud_health = newClientHudElem(self);
	self.hud_health.alignX = "right";
	self.hud_health.alignY = "top";
	self.hud_health.horzAlign = "right";
	self.hud_health.vertAlign = "top";
	self.hud_health.x = -2;
	self.hud_health.y = 120 + level.hudYOffset;
	self.hud_health.sort = 0;
	self.hud_health.fontScale = 1.6;
	self.hud_health.font = "objective";
	//self.hud_health.glowColor = level.randomcolour;
	self.hud_health thread braxi\_credits::GlowColour();
	self.hud_health.glowAlpha = 1;
	self.hud_health.hidewheninmenu = true;
	self.hud_health.label = &"Health: ";
	
	while( 1 )
	{
		self.hud_health setText(self.health+"/"+self.maxhealth);
		wait .002;
	}
}
Acti()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_actiname))
		self.hud_actiname destroy();

	self.hud_actiname = newClientHudElem(self);
	self.hud_actiname.alignX = "left";
	self.hud_actiname.alignY = "top";
	self.hud_actiname.horzAlign = "left";
	self.hud_actiname.vertAlign = "top";
	self.hud_actiname.x = 8;
	self.hud_actiname.y = 70 + level.hudYOffset;
	self.hud_actiname.sort = 0;
	self.hud_actiname.fontScale = 1.6;
	self.hud_actiname.font = "objective";
	//self.hud_actiname.glowColor = level.randomcolour;
	self.hud_actiname thread braxi\_credits::GlowColour();
	self.hud_actiname.glowAlpha = 1;
	self.hud_actiname.hidewheninmenu = true;
	
	while( 1 )
	{
		if(isDefined(level.activ))
		{
			self.hud_actiname setText("Activator: " + level.activ.name);
			self.hud_actiname.y = 70 + level.hudYOffset;
		}
		else
		{
			self.hud_actiname setText("Activator: None Choosen Yet!!!");
			self.hud_actiname.y = 70 + level.hudYOffset;
		}
		wait .002;
	}
}
BestPlayer()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_bestplayer))
		self.hud_bestplayer destroy();

	self.hud_bestplayer = newClientHudElem(self);
	self.hud_bestplayer.alignX = "left";
	self.hud_bestplayer.alignY = "top";
	self.hud_bestplayer.horzAlign = "left";
	self.hud_bestplayer.vertAlign = "top";
	self.hud_bestplayer.x = 8;
	self.hud_bestplayer.y = 50 + level.hudYOffset;
	self.hud_bestplayer.sort = 0;
	self.hud_bestplayer.fontScale = 1.6;
	self.hud_bestplayer.font = "objective";
	self.hud_bestplayer thread braxi\_credits::GlowColour();
	//self.hud_bestplayer.glowColor = level.randomcolour;
	self.hud_bestplayer.glowAlpha = 1;
	self.hud_bestplayer.hidewheninmenu = true;
	while( 1 )
	{
		noob = getBestPlayerFromScore( "score" );
		if(isDefined(self.pers["score"]))
			self.hud_bestplayer setText( "Best Player: " + noob.name );
		self.hud_bestplayer.y = 50 + level.hudYOffset;
		wait .002;
	}
}
StatsScore()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_StatsScore))
		self.hud_StatsScore destroy();

	self.hud_StatsScore = newClientHudElem(self);
	self.hud_StatsScore.alignX = "right";
	self.hud_StatsScore.alignY = "top";
	self.hud_StatsScore.horzAlign = "right";
	self.hud_StatsScore.vertAlign = "top";
	self.hud_StatsScore.x = -6;
	self.hud_StatsScore.y = 180 + level.hudYOffset;
	self.hud_StatsScore.sort = 0;
	self.hud_StatsScore.fontScale = 1.8;
	self.hud_StatsScore.font = "objective";
	self.hud_StatsScore thread braxi\_credits::GlowColour();
	//self.hud_StatsScore.glowColor = level.randomcolour;
	self.hud_StatsScore.glowAlpha = 1;
	self.hud_StatsScore.hidewheninmenu = true;
	self.hud_StatsScore.label = &"Score: &&1";
	while( 1 )
	{
		if(isDefined(self.pers["score"]))
			self.hud_StatsScore setValue( self.pers["score"] );
		wait .002;
	}
}

StatsKills()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_StatsKills))
		self.hud_StatsKills destroy();

	self.hud_StatsKills = newClientHudElem(self);
	self.hud_StatsKills.alignX = "right";
	self.hud_StatsKills.alignY = "top";
	self.hud_StatsKills.horzAlign = "right";
	self.hud_StatsKills.vertAlign = "top";
	self.hud_StatsKills.x = -6;
	self.hud_StatsKills.y = 200 + level.hudYOffset;
	self.hud_StatsKills.sort = 0;
	self.hud_StatsKills.fontScale = 1.8;
	self.hud_StatsKills.font = "objective";
	self.hud_StatsKills thread braxi\_credits::GlowColour();
	//self.hud_StatsKills.glowColor = level.randomcolour;
	self.hud_StatsKills.glowAlpha = 1;
	self.hud_StatsKills.hidewheninmenu = true;
	self.hud_StatsKills.label = &"Kills: &&1";
	
	while( 1 )
	{
		if(isDefined(self.pers["kills"]))
			self.hud_StatsKills setValue( self.pers["kills"] );
		wait .002;
	}
}

StatsDeaths()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_StatsDeaths))
		self.hud_StatsDeaths destroy();

	self.hud_StatsDeaths = newClientHudElem(self);
	self.hud_StatsDeaths.alignX = "right";
	self.hud_StatsDeaths.alignY = "top";
	self.hud_StatsDeaths.horzAlign = "right";
	self.hud_StatsDeaths.vertAlign = "top";
	self.hud_StatsDeaths.x = -6;
	self.hud_StatsDeaths.y = 220 + level.hudYOffset;
	self.hud_StatsDeaths.sort = 0;
	self.hud_StatsDeaths.fontScale = 1.8;
	self.hud_StatsDeaths.font = "objective";
	self.hud_StatsDeaths thread braxi\_credits::GlowColour();
//	self.hud_StatsDeaths.glowColor = level.randomcolour;
	self.hud_StatsDeaths.glowAlpha = 1;
	self.hud_StatsDeaths.hidewheninmenu = true;
	self.hud_StatsDeaths.label = &"Deaths: &&1";

	while( 1 )
	{
		if(isDefined(self.pers["deaths"]))
			self.hud_StatsDeaths setValue( self.pers["deaths"] );
		wait .002;
	}
	
}

StatsMelee()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_StatsMelee))
		self.hud_StatsMelee destroy();

	self.hud_StatsMelee = newClientHudElem(self);
	self.hud_StatsMelee.alignX = "right";
	self.hud_StatsMelee.alignY = "top";
	self.hud_StatsMelee.horzAlign = "right";
	self.hud_StatsMelee.vertAlign = "top";
	self.hud_StatsMelee.x = -6;
	self.hud_StatsMelee.y = 240 + level.hudYOffset;
	self.hud_StatsMelee.sort = 0;
	self.hud_StatsMelee.fontScale = 1.8;
	self.hud_StatsMelee.font = "objective";
	self.hud_StatsMelee thread braxi\_credits::GlowColour();
	//self.hud_StatsMelee.glowColor = level.randomcolour;
	self.hud_StatsMelee.glowAlpha = 1;
	self.hud_StatsMelee.hidewheninmenu = true;
	self.hud_StatsMelee.label = &"Knife: &&1";

	while( 1 )
	{
		if(isDefined(self.pers["knifes"]))
			self.hud_StatsMelee setValue( self.pers["knifes"] );
		wait .002;
	}
	
}


StatsHeadshot()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_StatsHeadshot))
		self.hud_StatsHeadshot destroy();

	self.hud_StatsHeadshot = newClientHudElem(self);
	self.hud_StatsHeadshot.alignX = "right";
	self.hud_StatsHeadshot.alignY = "top";
	self.hud_StatsHeadshot.horzAlign = "right";
	self.hud_StatsHeadshot.vertAlign = "top";
	self.hud_StatsHeadshot.x = -6;
	self.hud_StatsHeadshot.y = 260 + level.hudYOffset;
	self.hud_StatsHeadshot.sort = 0;
	self.hud_StatsHeadshot.fontScale = 1.8;
	self.hud_StatsHeadshot.font = "objective";
	self.hud_StatsHeadshot thread braxi\_credits::GlowColour();
	//self.hud_StatsHeadshot.glowColor = level.randomcolour;
	self.hud_StatsHeadshot.glowAlpha = 1;
	self.hud_StatsHeadshot.hidewheninmenu = true;
	self.hud_StatsHeadshot.label = &"Headshot: &&1";

	while( 1 )
	{
		if(isDefined(self.pers["headshots"]))
			self.hud_StatsHeadshot setValue( self.pers["headshots"] );
		wait .002;
	}
	
	
}
KilledJumpersStats()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_Statskilledjumpers))
		self.hud_Statskilledjumpers destroy();

	self.hud_Statskilledjumpers = newClientHudElem(self);
	self.hud_Statskilledjumpers.alignX = "left";
	self.hud_Statskilledjumpers.alignY = "top";
	self.hud_Statskilledjumpers.horzAlign = "left";
	self.hud_Statskilledjumpers.vertAlign = "top";
	self.hud_Statskilledjumpers.x = 8;
	self.hud_Statskilledjumpers.y = 220 + level.hudYOffset;
	self.hud_Statskilledjumpers.sort = 0;
	self.hud_Statskilledjumpers.fontScale = 1.6;
	self.hud_Statskilledjumpers.font = "objective";
	self.hud_Statskilledjumpers thread braxi\_credits::GlowColour();
	//self.hud_Statskilledjumpers.glowColor = level.randomcolour;
	self.hud_Statskilledjumpers.glowAlpha = 1;
	self.hud_Statskilledjumpers.hidewheninmenu = true;
	self.hud_Statskilledjumpers.label = &"Killed Jumpers: &&1";
	while( 1 )
	{
		kills = self maps\mp\gametypes\_persistence::statGet( "KILLED_JUMPERS" );
		
		if(isDefined(kills))
			self.hud_Statskilledjumpers setValue( int(kills) );
		wait .002;
	}
}

KilledactiStats()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_Statskilledacti))
		self.hud_Statskilledacti destroy();

	self.hud_Statskilledacti = newClientHudElem(self);
	self.hud_Statskilledacti.alignX = "left";
	self.hud_Statskilledacti.alignY = "top";
	self.hud_Statskilledacti.horzAlign = "left";
	self.hud_Statskilledacti.vertAlign = "top";
	self.hud_Statskilledacti.x = 8;
	self.hud_Statskilledacti.y = 240 + level.hudYOffset;
	self.hud_Statskilledacti.sort = 0;
	self.hud_Statskilledacti.fontScale = 1.6;
	self.hud_Statskilledacti.font = "objective";
	self.hud_Statskilledacti thread braxi\_credits::GlowColour();
//	self.hud_Statskilledacti.glowColor = level.randomcolour;
	self.hud_Statskilledacti.glowAlpha = 1;
	self.hud_Statskilledacti.hidewheninmenu = true;
	self.hud_Statskilledacti.label = &"Killed Activators: &&1";
	while( 1 )
	{
		kills = self maps\mp\gametypes\_persistence::statGet( "KILLED_ACTIVATORS" );
		
		if(isDefined(kills))
			self.hud_Statskilledacti setValue( int(kills) );
		wait .002;
	}
}

RankXpStats()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_Statsrankxp))
		self.hud_Statsrankxp destroy();

	self.hud_Statsrankxp = newClientHudElem(self);
	self.hud_Statsrankxp.alignX = "left";
	self.hud_Statsrankxp.alignY = "top";
	self.hud_Statsrankxp.horzAlign = "left";
	self.hud_Statsrankxp.vertAlign = "top";
	self.hud_Statsrankxp.x = 8;
	self.hud_Statsrankxp.y = 260 + level.hudYOffset;
	self.hud_Statsrankxp.sort = 0;
	self.hud_Statsrankxp.fontScale = 1.6;
	self.hud_Statsrankxp.font = "objective";
	self.hud_Statsrankxp thread braxi\_credits::GlowColour();
	//self.hud_Statsrankxp.glowColor = level.randomcolour;
	self.hud_Statsrankxp.glowAlpha = 1;
	self.hud_Statsrankxp.hidewheninmenu = true;
	self.hud_Statsrankxp.label = &"Rank Xp: &&1";
	
	while( 1 )
	{
		xp = self maps\mp\gametypes\_persistence::statGet( "rankxp");
		
		if(isDefined(xp))
			self.hud_Statsrankxp setValue( int(xp) );
		wait .002;
	}
}

RankStats()
{
	self endon("disconnect");
	
	if(isdefined(self.hud_Statsrank))
		self.hud_Statsrank destroy();

	self.hud_Statsrank = newClientHudElem(self);
	self.hud_Statsrank.alignX = "left";
	self.hud_Statsrank.alignY = "top";
	self.hud_Statsrank.horzAlign = "left";
	self.hud_Statsrank.vertAlign = "top";
	self.hud_Statsrank.x = 8;
	self.hud_Statsrank.y = 280 + level.hudYOffset;
	self.hud_Statsrank.sort = 0;
	self.hud_Statsrank.fontScale = 1.6;
	self.hud_Statsrank.font = "objective";
	self.hud_Statsrank thread braxi\_credits::GlowColour();
	//self.hud_Statsrank.glowColor = level.randomcolour;
	self.hud_Statsrank.glowAlpha = 1;
	self.hud_Statsrank.hidewheninmenu = true;
	self.hud_Statsrank.label = &"Rank: &&1";
	
	while( 1 )
	{
		rank = self maps\mp\gametypes\_persistence::statGet( "rank");
		
		if(isDefined(rank))
			self.hud_Statsrank setValue( int(rank) + 1 );
		wait .002;
	}
}

UpdateStats()
{
self endon( "disconnect" );
self endon( "joined_spectators" );
self endon( "endstats" );
plugins\_name::init();
}

fader(value)
{
	self fadeOverTime(.2);
	self.alpha = 0;
	wait .25;
	self setValue( value );
	self fadeOverTime(.6);
	self.alpha = 1;		
}

DestroyStats()
{
	self endon( "disconnect" );
	self endon( "joined_spectators" );
	self endon( "endstats" );
	p = braxi\_common::getAllPlayers();
	for(i=0;i<p.size;i++)
	{
		//p[i].hud_StatsScore thread killhud();
		//p[i].hud_StatsDeaths thread killhud();
		//p[i].hud_StatsMelee thread killhud();
		//p[i].hud_StatsHeadshot thread killhud();
	//	p[i].hud_StatsKills thread killhud();
	//	p[i].hud_bestplayer thread killhud();
	//	p[i].hud_actiname thread killhud();
		p[i].hud_health thread killhud();
	}
}

selfDestroyStats()
{
	self endon( "disconnect" );
	self endon( "joined_spectators" );
	self endon( "endstats" );
	//self.hud_StatsScore thread killhud();
	//self.hud_StatsDeaths thread killhud();
	//self.hud_StatsMelee thread killhud();
	//self.hud_StatsHeadshot thread killhud();
	//self.hud_StatsKills thread killhud();
	//self.hud_bestplayer thread killhud();
	//self.hud_actiname thread killhud();
	if(isDefined(self.hud_health))
	{
		self.hud_health thread killhud();
	}
	if(isDefined(self.hud_playermodstats))
	{
		self.hud_playermodstats thread killhud();
	}
	if(isDefined(self.hud_challengetask))
	{
		self.hud_challengetask thread killhud();
	}
	if(isDefined(self.hud_challengereward))
	{
		self.hud_challengereward thread killhud();
	}
	if(isDefined(self.hud_challengescore))
	{
		self.hud_challengescore thread killhud();
	}
}


killhud()
{
	self fadeOverTime(2);
	self.alpha = 0;
	wait 1;
	self destroy();
}