/*===================================================================||
||/|\///||/////||//||//||//\  \/////  //||
||/|  |//\  \//|  |/////|  |//|  |/////////|  |//////////\  \///  ///||
||/|  |///\  \/|  |/////|  |//|  |/////////|  |///////////\  \/  ////||
||/|  |///|  |/|  |/////|  |//|   _____|///|   _____|//////\    /////||
||/|  |////  //|  \/////|  |//|  |/////////|  |/////////////|  |/////||
||/|  |///  ////\  \////  ////|  |/////////|  |/////////////|  |/////||
||/|______ //////\_______/////|  |/////////|  |/////////////|  |/////||
||===================================================================*/
#include duffman\extras;
#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;
#include common_scripts\utility;

init()
{
	precacheItem( "radar_mp" );
	precacheItem( "airstrike_mp" );
	precacheItem( "helicopter_mp" );
	precacheItem( "artillery_mp" );	
	
	makeDvarServerInfo( "ui_uav_allies", 0 );
	makeDvarServerInfo( "ui_uav_axis", 0 );
	setDvar( "ui_uav_allies", 0 );
	setDvar( "ui_uav_axis", 0 );
	setDvar( "ui_uav_client", 0 );
	
	level.hardpointItems = [];
	priority = 0;
	level.hardpointItems["radar_mp"] = priority;
	priority++;
	level.hardpointItems["airstrike_mp"] = priority;
	priority++;
	level.hardpointItems["helicopter_mp"] = priority;
	priority++;
	precacheLocationSelector( "map_artillery_selector" );

	level.airstrikefx = loadfx ("explosions/clusterbomb");
	level.mortareffect = loadfx ("explosions/artilleryExp_dirt_brown");
	level.bombstrike = loadfx ("explosions/wall_explosion_pm_a");
	
	level.fx_airstrike_afterburner = loadfx ("fire/jet_afterburner");
	level.fx_airstrike_contrail = loadfx ("smoke/jet_contrail");
	
	level.fx_heli_dust = loadfx ("treadfx/heli_dust_default");
	level.fx_heli_water = loadfx ("treadfx/heli_water");
	level.artilleryDangerMaxRadius = 450;
	level.artilleryDangerMinRadius = 300;
	level.artilleryDangerForwardPush = 1.5;
	level.artilleryDangerOvalScale = 6.0;
	
	level.artilleryMapRange = level.artilleryDangerMinRadius * .3 + level.artilleryDangerMaxRadius * .7;
	
	level.artilleryDangerMaxRadiusSq = level.artilleryDangerMaxRadius * level.artilleryDangerMaxRadius;
	
	level.artilleryDangerCenters = [];
	
	level.radarViewTime = 30; // time radar remains active

	level.numHardpointReservedObjectives = 0;
	precacheShader("hud_suitcase_bomb");
	precachemodel ( "com_plasticcase_beige_big" );
	precacheItem("artillery_mp");
	precacheModel("projectile_cbu97_clusterbomb");
	precacheModel("vehicle_80s_sedan1_green_destructible_mp");
	precacheModel("vehicle_mig29_desert");
	precacheModel("vehicle_mi24p_hind_desert");
	precacheModel("vehicle_cobra_helicopter_fly");
	level.fx[0]=loadfx("fire/fire_smoke_trail_m");
	level.fx[1]=loadfx("fire/tank_fire_engine");
	level.fx[2]=loadfx("smoke/smoke_trail_black_heli");
	level.chopper_fx["explode"]["medium"] = loadfx("explosions/aerial_explosion");
	level.chopper_fx["fire"]["trail"]["medium"] = loadfx ("smoke/smoke_trail_black_heli");
	level.chopper_fx["explode"]["large"] = loadfx ("explosions/aerial_explosion_large");		
	level.nukecalled = false;
	level.napalm = false;
	level.bombing = false;  
	level.artilleryDangerMaxRadius = 100;
	level.cancallnuke = false;
	thread RandomNuke();
	thread playerSpawned();	
	thread playerKilled();
}

playerSpawned()
{
	while( 1 )
	{
		level waittill( "player_spawned", player );
		player thread KillSpec();
		player thread Streak_Launcher();
		player thread canSpawnNuke();
		if(getDvarint("bunnyhop") == 1 && getDvarInt("allowshit") == 1 )
			player thread duffman\bunnyhop::bunnyHoop();
	}
}

playerKilled()
{
	while( 1 )
	{
		level waittill( "player_killed", player );
		if(isDefined(player.entschaerfen))
			player.entschaerfen maps\mp\gametypes\_hud_util::destroyElem();				
	}
}

TakeDeagle()
{
	self endon("disconnect");
	self endon("death");
	for(;;)
	{
		if ( !self AnyAmmoForWeaponModes( "uzi_silencer_mp" ) )
		{
			self takeweapon("uzi_silencer_mp");
			self thread duffman\admincmd::clientCmd("weapnext");
			return;
		}
		wait .05;
	}
}

KillSpec()
{
	self endon("disconnect");
	self endon("death");
	for(;;)
	{
		while(isDefined(self.streak) && self.streak != 0)
		{
			//-----------Wurfmesser----------
			while(self.streak <= 2)
				wait .05;
			if(self.streak <=4)
			iPrintln("^2" + self.name +" ^7 has a killstreak of ^1" + self.streak);
				self GiveWeapon("frag_grenade_mp");
			self iPrintLnBold("^1You earned a ^3throwing knife. Press ^3[Frag] ^7to use it.");
			self.actualstreak = "messer";
			//-----------Kamikaze----------
			while(self.streak <= 4)
				wait .05;
			if(self.streak <=6)
			iPrintln("^2" + self.name +" ^7 has a killstreak of ^1" + self.streak);	
			self iPrintLnBold("^1You earned a ^3Kamikaze Bomber. Press ^3[[{+actionslot 4}]^3]^7 to use it.");
			self giveweapon("radar_mp");
			self SetActionSlot( 4, "weapon","radar_mp" );
			self.actualstreak = "kamikaze";
			//-----------Predator--------
			while(self.streak <= 6)
				wait .05;
			//self thread duffman\predator::reaper();
			if(self.streak <=9)
			iPrintln("^2" + self.name +" ^7 has a killstreak of ^1" + self.streak);	
						self giveweapon("radar_mp");
			self SetActionSlot( 4, "weapon","radar_mp" );
			self iPrintLnBold("^1You earned a ^3Predator. Press ^3[[{+actionslot 4}]^3]^7 to use it.");	
			self.actualstreak = "predator";			
			//------------Deagle-----------
			while(self.streak <= 9)
				wait .05;
			if(self.streak <=12)	
			iPrintln("^2" + self.name +" ^7 has a killstreak of ^1" + self.streak);	
			self GiveWeapon("uzi_silencer_mp");
			wait .1;
			self switchtoweapon("uzi_silencer_mp");
			self iPrintLnBold("^1You earned a ^3Deagle.");		
			self thread TakeDeagle();	
			self.actualstreak = "deagle";
			//-----------Reaper--------
			while(self.streak <= 12)
				wait .05;
			//self thread duffman\reaper::reaper();
			iPrintln("^2" + self.name +" ^7 has a killstreak of ^1" + self.streak);	
						self giveweapon("radar_mp");
			self SetActionSlot( 4, "weapon","radar_mp" );
			self iPrintLnBold("^1You earned a ^3Reaper. Press ^3[[{+actionslot 4}]^3]^7 to use it.");
			self.actualstreak = "reaper";			
			//-------------Nuke------------
			while(self.streak <= 19)
				wait .05;
			iPrintln("^2" + self.name +" ^7 has a killstreak of ^1" + self.streak);				
			self thread Nuke_Launch();
			self iPrintlnBold("^1You earned a ^3Nuke");
			self.actualstreak = "nuke";
			while(self.streak <= 999)
				wait .05;			
			wait .05;
		}
		wait .05;
	}
}

HeliFlyIn(ori)
{
	level.flyin = spawn("script_model",(ori[0],20000,5000));
	level.flyin setModel("vehicle_cobra_helicopter_fly");
	level.flyin.angles = (10, 270, 0);
	level.flyin playloopsound("mp_hind_helicopter");
	level.nukelauncher2 = spawn( "script_model", (ori[0],20000,4800) );
	level.nukelauncher2 setModel( "com_plasticcase_beige_big" );
	level.nukelauncher2.angles = (0, 270, 0);
	
	wait .05;
	
	level.flyin MoveTo((ori[0],ori[1],5000),10);
	level.nukelauncher2 MoveTo((ori[0],ori[1],4800),10);
	level.nukelauncher2 waittill("movedone");
	level.flyin MoveTo((0,-20000,5000),10);
	level.nukelauncher2 MoveTo((ori),2);
	wait 11;
	level.flyin stoploopsound("mp_hind_helicopter");
	level.flyin delete();
}

Streak_Launcher()
{
	self endon("disconnect");
	self endon("death");
	wait 1;
	for(;;)
	{
		self.curweap2 = self getCurrentWeapon();
				
		self waittill("weapon_change");
		
		if(self getCurrentWeapon() == "radar_mp")
		{
			if(self.actualstreak == "kamikaze")
				thread KamikazeBomber(self);
			else if(self.actualstreak == "predator")
				self thread duffman\predator::reaper();
			else if(self.actualstreak == "reaper")
				self thread duffman\reaper::reaper();
			wait .3;
			self TakeWeapon( "radar_mp");
			wait 0.1;
			if(self.curweap2 != "none")
				self switchToWeapon( self.curweap2 );
			wait 2;
		}
		wait .05;
	}
}

Nuke_Launch()
{
	self endon("disconnect");
	level.nukelauncher = spawn( "script_model", (self.origin+(0,-10,0)) );
	level.nukelauncher setModel( "com_plasticcase_beige_big" );
	timer = 3;
	for(;;)
	{
		self maps\mp\_utility::clearLowerMessage();
		if(isdefined(level.nukelauncher) && distance(self.origin, level.nukelauncher.origin) <40 && !level.oitcrunning)
		{
			self maps\mp\_utility::setLowerMessage("^7Press ^3[[{+usereload}]] ^7to call a Nuke!");
			if(self usebuttonpressed() && self.sessionstate == "playing")
			{
				self DisableWeapons();
				self freezeControls( true );
				self.entschaerfen = self maps\mp\gametypes\_hud_util::createBar((1,1,1), 128, 8);
				self.entschaerfen maps\mp\gametypes\_hud_util::setPoint("CENTER", 0, 0, 0);
				self.entschaerfen maps\mp\gametypes\_hud_util::updateBar(0, 1/timer );
				for(i=0;i<61;i++)
				{
					if(!self UseButtonPressed() || self.sessionstate != "playing")
					{
						if(isDefined(self.entschaerfen))
							self.entschaerfen maps\mp\gametypes\_hud_util::destroyElem();	
						self EnableWeapons();
						self freezeControls( false );
						i = 100;
					}
					wait .05;
					if(i == 60)
					{
						if(!level.nukecalled)
						{
							thread nuke(level.nukelauncher.origin,self,true);
							if(isdefined(level.nukelauncher))
							level.nukelauncher delete();
							level.nukecalled = true;
						}
						if(isDefined(self.entschaerfen))
							self.entschaerfen maps\mp\gametypes\_hud_util::destroyElem();	
						self EnableWeapons();
						self freezeControls( false );
						self maps\mp\_utility::clearLowerMessage();
						return;
					}
				}
			}
		}
		wait .05;
	}
							if(isDefined(self.entschaerfen))
							self.entschaerfen maps\mp\gametypes\_hud_util::destroyElem();	
}

BlurFade(time,ammout,startblur)
{	
	self endon("disconnect");
	if(!isDefined(time) || !isDefined(ammout) )	return;
	if(ammout <= startblur) add = false;
	else add = true;
	milisecs = time * 20;
	add2blur = ammout / 20;
	for(i=0;i<milisecs;i++)
	{
		if(add)
			startblur += add2blur;
		else
			startblur -= add2blur;			
		self setClientDvar("r_blur", startblur);
		wait .05;
	}

}

Nuke(ori,owner,endround)
{
	while(isDefined(level.nukeinuse) && level.nukeinuse)
		wait .05;
		
	level.nukeinuse = true;
	thread NukeTimer();
	wait 18;
	dvarOnPlayer("r_fog", "1");
	SetExpFog(9999999, 999999994, 1, 1, 1, 2);
	players = getAllPlayers();
	for( i = 0; i < players.size; i++ )
	{
		players[i] thread BlurFade(2,.7,0);
	}
	setdvar("timescale", ".9");
	wait 0.5;
	SetExpFog(256, 512, 1, 0, 0, 2);
	setdvar("timescale", ".8");
	wait 0.5;
	setdvar("timescale", ".7");
	dvarOnPlayer ("r_filmusetweaks", "0");
	VisionSetNaked( "cargoship_blast", 2 );
	wait 0.5;
	Earthquake( 0.8, 5, owner.origin, 999999 );
	setdvar("timescale", ".6");
	wait 0.5;
	playSoundOnAllPlayers( "artillery_impact" );
	playSoundOnAllPlayers( "artillery_impact" );
	playSoundOnAllPlayers( "artillery_impact" );
	playSoundOnAllPlayers( "artillery_impact" );
	playSoundOnAllPlayers( "artillery_impact" );
	owner suicide();
	players = getAllPlayers();
	for( i = 0; i < players.size; i++ )
	{
		if(isDefined(players[i]) && players[i] != owner && players[i].sessionstate == "playing" )
			players[i] thread [[level.callbackPlayerDamage]](owner,owner,2147483647,8,"MOD_RIFLE_BULLET",owner getCurrentWeapon(),(0,0,0),(0,0,0),"torso_upper",0);
	}
	wait .1;
	players = getAllPlayers();
	for( i = 0; i < players.size; i++ )
	{	
		if(isDefined(players[i]) && players[i].sessionstate == "playing")
			players[i] suicide();
	}
	
	playFxonAll(level.chopper_fx["explode"]["medium"]);
	playFx(level.chopper_fx["explode"]["large"],ori);
	Earthquake( 0.8, 5, owner.origin, 999999 );
	wait 0.4;
	setdvar("timescale", ".6");
	players = getAllPlayers();
	for( i = 0; i < players.size; i++ )
	{
		players[i] thread BlurFade(1.5,0,.7);
	}
	wait 0.5;
	setdvar("timescale", ".7");
	wait 0.5;
	setdvar("timescale", ".8");
	wait 0.5; 
	if(isDefined(endround) && endround )
		thread maps\mp\gametypes\_globallogic::default_onTimeLimit();
	setdvar("timescale", ".9");
	//dvarOnPlayer ("r_filmusetweaks", "1");
	dvarOnPlayer("r_fog", "0");
	//dvarOnPlayer("r_blur", "0");
	visionSetNaked( getDvar( "mapname" ), 1 );
	players = getAllPlayers();
	for( i = 0; i < players.size; i++ )
		players[i] thread promod\client::use_config();
	
	wait 0.1;
	setdvar("timescale", "1");
	if(isDefined(endround) && endround)
	{
		players = getAllPlayers();
		for( i = 0; i < players.size; i++ )
		{
			players[i] freezecontrols(true);
		}
	}
		
	level.nukeinuse = false;
}

NukeTimer()
{
	level.nuke_icon = newHudElem();
    level.nuke_icon.foreground = true;
	level.nuke_icon.alignX = "left";
	level.nuke_icon.alignY = "top";
	level.nuke_icon.horzAlign = "left";
    level.nuke_icon.vertAlign = "top";
    level.nuke_icon.x = 115;
    level.nuke_icon.y = 20;
	level.nuke_icon.alpha = 0;
	level.nuke_icon.sort = 100;
 	level.nuke_icon.hidewheninmenu = true;
	level.nuke_icon.archived = false;
	level.nuke_icon setShader("hud_suitcase_bomb", 39, 39);
	level.nuke_icon FadeOverTime(.5);
	level.nuke_icon.alpha = 1;

	level.nuketimer = newHudElem();
    level.nuketimer.foreground = true;
	level.nuketimer.alignX = "left";
	level.nuketimer.alignY = "top";
	level.nuketimer.horzAlign = "left";
    level.nuketimer.vertAlign = "top";
    level.nuketimer.x = 115;
    level.nuketimer.y = 53;
    level.nuketimer.sort = 0;
	level.nuketimer.alpha = 0;
  	level.nuketimer.fontScale = 1.6;
	level.nuketimer.color = (1, .5, 0);
	level.nuketimer.font = "objective";
 	level.nuketimer.hidewheninmenu = true;
	level.nuketimer setTimer(20);
	level.nuketimer FadeOverTime(.5);
	level.nuketimer.alpha = 1;
	
	for(i=0;i<21;i++)
	{
		level thread playSoundOnAllPlayers( "mouse_over" );
		wait 1;
	}
	
	level.nuketimer FadeOverTime(.5);
	level.nuketimer.alpha = 0;
	level.nuke_icon FadeOverTime(.5);
	level.nuke_icon.alpha = 0;	
	wait .5;
	level.nuketimer destroy();
	level.nuke_icon destroy();
}

RandomNuke()
{
	self endon("disconnect");
	ori = undefined;
	wait 500; //500
	spawntime = randomInt(200);//200
	wait spawntime;
	while(!isDefined(ori))
	{
		wait .05;
		players = getAllPlayers();
		for( i = 0; i < players.size; i++ )
		{
			if(isDefined(players[i]) && players[i] isonground() && BulletTracePassed( players[i].origin, players[i].origin + ( 0, 0 , 600), false, undefined) && players[i].sessionstate == "playing")
				ori = players[i].origin;
		}
	}
	time = randomInt(100);//100
	wait time;
	
	if(isdefined(ori))
	{	
		thread HeliFlyIn(ori);
		wait 10;
		level.cancallnuke = true;
	}
}

canSpawnNuke()
{
	self endon("disconnect");
	self endon("death");
	while(!level.cancallnuke)
		wait .05;
	timer = 3;
	for(;;)
	{
		self maps\mp\_utility::clearLowerMessage();
		if(isdefined(level.nukelauncher2) && distance(self.origin, level.nukelauncher2.origin) <40 && !level.oitcrunning)
		{
			self maps\mp\_utility::setLowerMessage("^7Press ^3[[{+usereload}]] ^7to call a Nuke!");
			if(self usebuttonpressed() && self.sessionstate == "playing" )
			{
				self DisableWeapons();
				self freezeControls( true );
				self.entschaerfen = self maps\mp\gametypes\_hud_util::createBar((1,1,1), 128, 8);
				self.entschaerfen maps\mp\gametypes\_hud_util::setPoint("CENTER", 0, 0, 0);
				self.entschaerfen maps\mp\gametypes\_hud_util::updateBar(0, 1/timer );
				for(i=0;i<61;i++)
				{
					if(!self UseButtonPressed() || self.sessionstate != "playing")
					{
						if(isDefined(self.entschaerfen))
							self.entschaerfen maps\mp\gametypes\_hud_util::destroyElem();	
						self EnableWeapons();
						self freezeControls( false );
						i = 100;
					}
					wait .05;
					if(i == 60 )
					{
						if(!level.nukecalled)
						{
							thread nuke(level.nukelauncher2.origin,self,true);
							level.nukelauncher2 delete();
							level.nukecalled = true;
						}
						if(isDefined(self.entschaerfen))
							self.entschaerfen maps\mp\gametypes\_hud_util::destroyElem();	
						self EnableWeapons();
						self freezeControls( false );
						self maps\mp\_utility::clearLowerMessage();
						return;
					}
				}
			}
		}
		wait .05;
	}
							if(isDefined(self.entschaerfen))
							self.entschaerfen maps\mp\gametypes\_hud_util::destroyElem();	
}



KamikazeBomber(player) 
{ 
	wait 1;
	while(isDefined(level.kamikazeinuse) && level.kamikazeinuse)
		wait .05;
		
	level.kamikazeinuse = true;	
	location = (0, 0, player.origin[2]);
	loc = undefined;
	random = randomint(4);
	switch(getDvar("mapname"))
	{
	case "mp_crossfire":
		switch(random)
		{
			case 0:
				loc = (4610, -1241, 82);
				break;
			case 1:
				loc = (5378, -1684, 74);
				break;	
			case 2:
				loc = (4647, -3022, -52);
				break;
			case 3:
				loc = (5057, -2315, 42);
				break;
			default: loc = (0, 0, player.origin[2]);
		}
		break;
		
	case "mp_crash":
		switch(random)
		{
			case 0:
				loc = (331, 284, 203);
				break;
			case 1:
				loc = (54, -321, 196);
				break;	
			case 2:
				loc = (1063, -776, 131);
				break;
			case 3:
				loc = (1106, 867, 195);
				break;
			default: loc = (0, 0, player.origin[2]);
		}
		break;
		
	case "mp_backlot":
		switch(random)
		{
			case 0:
				loc = (-361, 1401, 124);
				break;
			case 1:
				loc = (-133, -41, 127);
				break;	
			case 2:
				loc = (-60, -916, 118);
				break;
			case 3:
				loc = (928, 6, 119);
				break;
			default: loc = (0, 0, player.origin[2]);
		}
		break;		
		
	case "mp_nuketown":
		switch(random)
		{
			case 0:
				loc = (159, 520, 83);
				break;
			case 1:
				loc = (429, -406, 83);
				break;	
			case 2:
				loc = (-1236, 337, 172);
				break;
			case 3:
				loc = (1529, 225, 156);
				break;
			default: loc = (0, 0, player.origin[2]);
		}
		break;	
		
	case "mp_strike":
		switch(random)
		{
			case 0:
				loc = (-1131, -226, 68);
				break;
			case 1:
				loc = (448, -56, 68);
				break;	
			case 2:
				loc = (-561, 710, 112);
				break;
			case 3:
				loc = (-372, 13, 107);
				break;
			default: loc = (0, 0, player.origin[2]);
		}
		break;	
		
	default: loc = (0, 0, player.origin[2]);
	}
	Kamikaze = spawn("script_model", (loc + ( 4400, 2950, 6000 ))); 
	Kamikaze setModel( "vehicle_mig29_desert" ); 
	Angles = vectorToAngles( loc - (player.origin+(8000,5000,10000))); 
	Kamikaze.angles = Angles; 

	Kamikaze moveto(loc, 2.5); 
	for(i=0;i<50;i++)
	{
		playfx(level.chopper_fx["fire"]["trail"]["medium"] ,(Kamikaze.origin  + ( 44, 29.5, 60 )));
		playfx(level.fx[0] ,(Kamikaze.origin  + ( 44, 29.5, 60 )));
		Kamikaze playloopsound("veh_mig29_dist_loop");
		wait .05;
	}
	Kamikaze stoploopsound("veh_mig29_dist_loop");
	Kamikaze moveto(loc-(0,0,5000), .1); 
	Kamikaze playSound( "exp_suitcase_bomb_main" ); 
	Kamikaze playSound( "exp_suitcase_bomb_main" ); 
	Kamikaze playSound( "exp_suitcase_bomb_main" ); 
	Kamikaze playSound( "exp_suitcase_bomb_main" ); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(400,0,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(0,400,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(400,400,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(0,0,400)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin-(400,0,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin-(0,400,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin-(400,400,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(0,0,800)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(200,0,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(0,200,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(200,200,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(0,0,200)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin-(200,0,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin-(0,200,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin-(200,200,0)); 
	playFX(level.chopper_fx["explode"]["large"], Kamikaze.origin+(0,0,200)); 
	Earthquake( 0.4, 4, Kamikaze.origin, 800 ); 
	players = getAllPlayers();
	for( i = 0; i < players.size; i++ )
	{
		if(isDefined(players[i]) && players[i] != player && players[i].sessionstate == "playing" )
		{
			if ( level.teamBased ) 
			{
				if(players[i].team != player.team)
				{	
					if( distance(Kamikaze.origin, players[i].origin) <= 700 )
						players[i] thread [[level.callbackPlayerDamage]](player,player,300,8,"MOD_RIFLE_BULLET","airstrike_mp",(0,0,0),(0,0,0),"torso_upper",0);
				}
			}
			else
			{
				if( distance(Kamikaze.origin, players[i].origin) <= 700 )
					players[i] thread [[level.callbackPlayerDamage]](player,player,300,8,"MOD_RIFLE_BULLET","airstrike_mp",(0,0,0),(0,0,0),"torso_upper",0);
			}
		}
	}
	wait .1;
	RadiusDamage( Kamikaze.origin, 1000, 1000, 1, player ); 
	Kamikaze delete(); 
	level.kamikazeinuse = false;	
}

