#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;
#include common_scripts\utility;

initGunner() {

    if (getDvar("ChopperGunner") == "1") {
        i("Chopper Gunner Already in Use");

    }
    if (getDvar("ChopperGunner") == "0") {

        self thread doGunner();
    }
}

doGunner() {
    self endon("enter");
    setDvar("ChopperGunner", "1");
    self.gun = self getcurrentweapon();
    i("Chopper Gunner Ready");
    wait 2;
    i("Press [{+actionslot 4}] To Enter");
    self giveWeapon("briefcase_bomb_mp");
    self SetActionSlot(4, "");
    wait 0.1;
    self SetActionSlot(4, "weapon", "briefcase_bomb_mp");
    wait 0.1;
    for (;;) {
        if (self getcurrentweapon() == "briefcase_bomb_mp") {
            wait 0.3;
            self thread gunny();
        }
        wait 0.3;
    }
}


gunny() {
/*Chopper Gunner by x_DaftVader_x*/

    self notify("enter");
    team = self.pers["team"];
    otherTeam = level.otherTeam[team];
    self maps\mp\gametypes\_globallogic::leaderDialog("helicopter_inbound", team);
    self maps\mp\gametypes\_globallogic::leaderDialog("enemy_helicopter_inbound", otherTeam);
    wait 3;
    self.cs = createIcon("black", 1000, 1000);
    self.cs setPoint("CENTER", "CENTER");
    self.cs.alpha = 1.5;
    level.height = 850;
    if (isdefined(level.airstrikeHeightScale)) {
        level.height *= level.airstrikeHeightScale;
    }
    level.mapCenter = maps\mp\gametypes\_spawnlogic::findBoxCenter(level.spawnMins, level.spawnMaxs);
    start = self.origin + (0, 0, level.height);
    self.ChopperGunner = true;
    self thread ChopperGunner(start);
}
ChopperGunner(start) {
    self allowAds(false);
    weapon = self getcurrentweapon();
    pos = self getOrigin();
    chopper = spawn("script_model", start);
    chopper setModel("vehicle_cobra_helicopter_fly");
    chopper notsolid();
    chopper setcontents(0);
    self thread GunnerFly(chopper, start);
    chopper playLoopSound("mp_hind_helicopter");
    self thread monitorfire();
    self thread monitordrop();
    self thread firegunner();
    self thread dropchopper(chopper); 
	self thread HeliGod();
	wait 0.1;
    self linkTo(chopper, "tag_player", (0, 0, 3), (0, 0, 0));
    self detachAll();
    self hide();
    wait 1.9;
    self.cs.alpha = 1.2;
    wait 0.3;
    self.cs.alpha = 1;
    wait 0.3;
    self.cs.alpha = 0.5;
    wait 0.3;
    self.cs destroy();
    self takeallweapons();
    self thread GunnerGun();
    wait 0.1;
    self thread EndGunner(chopper, weapon, pos);
}
GunnerGun() {
    self thread crosshairs(0, -35, 8, 2);
    self thread crosshairs(0, 35, 8, 2);
    self thread crosshairs(-29, 0, 2, 8);
    self thread crosshairs(29, 0, 2, 8);
    self thread crosshairs(-64, 0, 2, 9);
    self thread crosshairs(64, 0, 2, 9);
    self thread crosshairs(0, -65, 2, 65);
    self thread crosshairs(0, 65, 2, 65);
    self thread crosshairs(-65, 0, 65, 2);
    self thread crosshairs(65, 0, 65, 2);
    self thread greenscreen(0, 0, 840, 900);
}
EndGunner(chopper, weapon, pos) {
    self endon("death");
    self endon("disconnect");
    wait 90;
    self unlink();
    self notify("boom");
    self allowAds(true);
    self show();
    chopper delete();
    self SetOrigin(pos);
    self freezeControls(false);
    self giveWeapon(self.gun);
    self thread playerModelForWeapon(self.gun);
    self giveweapon("deserteaglegold_mp");
    wait 0.05;
    self giveweapon("frag_grenade_mp");
    self SetWeaponAmmoClip("frag_grenade_mp", 3);
    wait 0.1;
    self switchtoweapon(self.gun);
    setDvar("ChopperGunner", "0");
    self thread HeliGodOff();
    self notify("die");
 
}
monitorfire() {
    self endon("die");
    self endon("chopper_down");
    self endon("death");
    for (;;) {
        if (self attackbuttonpressed()) self notify("fire");
        wait 0.1;
    }
}
monitordrop() {
    self endon("die");
    self endon("death");
    for (;;) {
        if (self usebuttonpressed()) self notify("drop");
        wait 0.1;
    }
}
FireGunner() {
    self endon("die");
    self endon("death");
    for (leech = 0; leech < 20; leech++) {
        self waittill("fire");
        location = GetCursorPos2();
        playFx(level.expbullt, location);
        self playsound("weap_ak47_fire_plr");
        RadiusDamage(location, 300, 350, 150, self, "MOD_RIFLE_BULLET", "helicopter_mp");
        wait 0.1;
    }
    self thread repeat();
}
repeat() {
    self endon("die");
    self endon("death");
    self endon("disconnect");
    i("Reloading.....");
    wait 1.5;
    self thread FireGunner();
}

dropchopper(chopper) {
    self endon("die");
    self endon("death");
    for (;;) {
        i("Press [{+usereload}] to drop chopper");
        self waittill("drop");

        chopper moveto(self.origin - (0, 0, 300), 3, 0.1); 
        wait 20;
    }
}
crosshairs(x, y, width, height) {
    C = newClientHudElem(self);
    C.width = width;
    C.height = height;
    C.align = "CENTER";
    C.relative = "MIDDLE";
    C.children = [];
    C.sort = 3;
    C.alpha = 0.3;
    C setParent(level.uiParent);
    C setShader("white", width, height);
    C.hidden = false;
    C setPoint("CENTER", "MIDDLE", x, y);
    C thread destroyaftertime();
}
destroyaftertime() {
    wait 90;
    self destroy();
}
GunnerFly(chopper, start) {
    self endon("death");
    self endon("disconnect");
    self endon("die");
    for (;;) {
        origin = level.mapcenter + (0, 0, level.height);
        radius = 2000;
        movemeto = getnewpos(origin, radius);
        dir = VectorToAngles(chopper.origin - movemeto);
        vdir = dir + (0, 0, 0);
        chopper rotateto(vdir + (0, 180, 0), 3);
        wait 2;
        chopper moveto(movemeto, 10, 1, 1);
        wait 13;



    }
}
GetCursorPos2() {
return BulletTrace(self getTagOrigin("tag_weapon_right"), maps\mp\_utility::vector_scale(anglestoforward(self getPlayerAngles()), 1000000), false, self)["position"];
}

PHud(x, y, width, height) {
    p = newClientHudElem(self);
    p.width = width;
    p.height = height;
    p.align = "CENTER";
    p.relative = "MIDDLE";
    p.children = [];
    p.sort = 3;
    p.alpha = 0.5;
    p setParent(level.uiParent);
    p setShader("white", width, height);
    p.hidden = false;
    p setPoint("CENTER", "MIDDLE", x, y);
    self thread destroyvision(p);

}
Greenscreen(x, y, width, height) {
    g = newClientHudElem(self);
    g.width = width;
    g.height = height;
    g.align = "CENTER";
    g.relative = "MIDDLE";
    g.children = [];
    g.sort = 1;
    g.alpha = 0.2;
    g setParent(level.uiParent);
    g setShader("white", width, height);
    g.hidden = false;
    g.color = (0, 1, 0);
    g setPoint("CENTER", "MIDDLE", x, y);
    self thread destroyvision(g);

}
destroyvision(x) {
    self endon("clear");
    for (;;) {
        self waittill("boom");
        x destroyelem();
        wait 0.1;
        self notify("clear");
    }
}
getnewPos(origin, radius) {

pos = origin + ((randomfloat(2) - 1) * radius, (randomfloat(2) - 1) * radius, 0);
while (distanceSquared(pos, origin) > radius * radius)
pos = origin + ((randomfloat(2) - 1) * radius, (randomfloat(2) - 1) * radius, 0);
return pos;
}
i(text) {
    self iprintln(text);
}

playerModelForWeapon( weapon )
{
self detachAll();
weaponClass = tablelookup( "mp/statstable.csv", 4, weapon, 2 );
switch ( weaponClass )
{
case "weapon_smg": [[game[self.pers["team"]+"_model"]["SPECOPS"]]]();
break;
case "weapon_assault": [[game[self.pers["team"]+"_model"]["ASSAULT"]]]();
break;
case "weapon_sniper": [[game[self.pers["team"]+"_model"]["SNIPER"]]]();
break;
case "weapon_shotgun": [[game[self.pers["team"]+"_model"]["RECON"]]]();
break;
case "weapon_lmg": [[game[self.pers["team"]+"_model"]["SUPPORT"]]]();
break;
default: [[game[self.pers["team"]+"_model"]["ASSAULT"]]]();
break;
}
}

HeliGod()
{
	self endon("disconnect");
	self endon("death");
	self endon("heli_godoff");
	self.maxhealth = 90000;
	for(;;)
	{
		self.health = self.maxhealth;
		wait 0.05;
	}
}
HeliGodOff()
{
	self.maxhealth = 100;
	self.health = self.maxhealth;
	self notify("heli_godoff");
}

doac130()
{
	self thread maps\mp\gametypes\menubase::ExitMenu();
	self.ac130Enabled = true;
	if( getdvar("mapname") == "mp_bloc" )
		self.Ac130Loc = (1100, -5836, 1800);
		
	else if( getdvar("mapname") == "mp_crossfire" )
		self.Ac130Loc = (4566, -3162, 1800);
		
	else if( getdvar("mapname") == "mp_citystreets" )
		self.Ac130Loc = (4384, -469, 1500);
		
	else if( getdvar("mapname") == "mp_creek" )
		self.Ac130Loc = (-1595, 6528, 2000);
		
	else
	{
		level.mapCenter = maps\mp\gametypes\_spawnlogic::findBoxCenter( level.spawnMins, level.spawnMaxs );
		self.Ac130Loc = getAboveBuildings( level.mapCenter );
	}
	self.Ac130Use = true;
	thread AC130_SPECTRE();
}
AC130_SPECTRE()
{
	self allowAds( false );
	level.ac["105mm"] = loadfx("explosions/aerial_explosion_large");
	level.ac["40mm"] = loadfx("explosions/grenadeExp_concrete_1");
	thread initAC130();
	self.OldOrigin = self getOrigin();
	thread playerLinkAC130( self.Ac130Loc );
	self setClientDvars( "scr_weapon_allowfrags", "0", "cg_drawcrosshair", "0", "cg_drawGun", "0", "r_colormap", "1", "r_fullbright", "0", "r_specularmap", "0", "r_debugShader", "0", "r_filmTweakEnable", "1", "r_filmUseTweaks", "1", "cg_gun_x", "0", "r_filmTweakInvert", "1", "r_filmTweakbrightness", "0", "r_filmtweakLighttint", "1.1 1.05 0.85", "r_filmtweakdarktint", "0.7 0.85 1" );
	self.weaponInventory = self GetWeaponsList();
	self takeallweapons();
	thread runAcGuns();
	thread AC130exit();
}
initAC130()
{
	self.initAC130[0] = ::weapon105mm;
	self.initAC130[1] = ::weapon40mm;
	self.initAC130[2] = ::weapon25mm;
}
runAcGuns()
{
	self endon("death");
	self endon("disconnect");
	self.HudNum = 0;
	thread [[self.initAC130[self.HudNum]]]();
	while( self.Ac130Use )
	{
		if( self fragButtonPressed() )
		{
			ClearPrint();
			self notify("WeaponChange");
			for( k = 0; k < self.ACHud[self.HudNum].size; k++ )
				self.ACHud[self.HudNum][k] destroyElem();
				
			self.HudNum ++;
			if( self.HudNum >= self.initAC130.size )
				self.HudNum = 0;
				
			thread [[self.initAC130[self.HudNum]]]();
			wait 0.5;
		}
		wait 0.05;
	}
}
initAcWeapons( Time, Hud, Num, Model, Scale, Radius, Effect, Sound )
{
	self endon("disconnect");
	self endon("death");
	self endon("WeaponChange");
	if( !isDefined( self.BulletCount[Hud] ) )
		self.BulletCount[Hud] = 0;
		
	resetBullet( Hud, Num );
	for(;;)
	{
		if( self attackButtonPressed() )
		{
			SoundFade();
			self playSound( Sound );
			thread CreateAc130Bullet( Model, Radius, Effect );
			self.BulletCount[Hud] ++;
			if( self.BulletCount[Hud] <= Num )
				Earthquake( Scale, 0.2, self.origin, 200 );
				
			resetBullet( Hud, Num );
			wait Time;
		}
		wait 0.05;
	}
}
weapon105mm()
{
	self.ACHud[0][0] = createHuds(21,0,2,24);
	self.ACHud[0][1] = createHuds(-20,0,2,24);
	self.ACHud[0][2] = createHuds(0,-11,40,2);
	self.ACHud[0][3] = createHuds(0,11,40,2);
	self.ACHud[0][4] = createHuds(0,-39,2,57);
	self.ACHud[0][5] = createHuds(0,39,2,57);
	self.ACHud[0][6] = createHuds(-48,0,57,2);
	self.ACHud[0][7] = createHuds(49,0,57,2);
	self.ACHud[0][8] = createHuds(-155,-122,2,21);
	self.ACHud[0][9] = createHuds(-154,122,2,21);
	self.ACHud[0][10] = createHuds(155,122,2,21);
	self.ACHud[0][11] = createHuds(155,-122,2,21);
	self.ACHud[0][12] = createHuds(-145,132,21,2);
	self.ACHud[0][13] = createHuds(145,-132,21,2);
	self.ACHud[0][14] = createHuds(-145,-132,21,2);
	self.ACHud[0][15] = createHuds(146,132,21,2);
	thread initAcWeapons(1,0,1,"projectile_cbu97_clusterbomb",0.4,350,level.ac["105mm"],"weap_barrett_fire_plr");
}
weapon40mm()
{
	self.ACHud[1][0] = createHuds(0,-70,2,115);
	self.ACHud[1][1] = createHuds(0,70,2,115);
	self.ACHud[1][2] = createHuds(-70,0,115,2);
	self.ACHud[1][3] = createHuds(70,0,115,2);
	self.ACHud[1][4] = createHuds(0,-128,14,2);
	self.ACHud[1][5] = createHuds(0,128,14,2);
	self.ACHud[1][6] = createHuds(-128,0,2,14);
	self.ACHud[1][7] = createHuds(128,0,2,14);
	self.ACHud[1][8] = createHuds(0,-35,8,2);
	self.ACHud[1][9] = createHuds(0,35,8,2);
	self.ACHud[1][10] = createHuds(-29,0,2,8);
	self.ACHud[1][11] = createHuds(29,0,2,8);
	self.ACHud[1][12] = createHuds(-64,0,2,9);
	self.ACHud[1][13] = createHuds(64,0,2,9);
	self.ACHud[1][14] = createHuds(0,-85,10,2);
	self.ACHud[1][15] = createHuds(0,85,10,2);
	self.ACHud[1][16] = createHuds(-99,0,2,10);
	self.ACHud[1][17] = createHuds(99,0,2,10);
	thread initAcWeapons(0.2,1,5,"projectile_hellfire_missile",0.3,80,level.ac["40mm"],"weap_deserteagle_fire_plr");
}
weapon25mm()
{
	self.ACHud[2][0] = createHuds(21,0,35,2);
	self.ACHud[2][1] = createHuds(-21,0,35,2);
	self.ACHud[2][2] = createHuds(0,25,2,46);
	self.ACHud[2][3] = createHuds(-60,-57,2,22);
	self.ACHud[2][4] = createHuds(-60,57,2,22);
	self.ACHud[2][5] = createHuds(60,57,2,22);
	self.ACHud[2][6] = createHuds(60,-57,2,22);
	self.ACHud[2][7] = createHuds(-50,68,22,2);
	self.ACHud[2][8] = createHuds(50,-68,22,2);
	self.ACHud[2][9] = createHuds(-50,-68,22,2);
	self.ACHud[2][10] = createHuds(50,68,22,2);
	self.ACHud[2][11] = createHuds(6,9,1,7);
	self.ACHud[2][12] = createHuds(9,6,7,1);
	self.ACHud[2][13] = createHuds(11,14,1,7);
	self.ACHud[2][14] = createHuds(14,11,7,1);
	self.ACHud[2][15] = createHuds(16,19,1,7);
	self.ACHud[2][16] = createHuds(19,16,7,1);
	self.ACHud[2][17] = createHuds(21,24,1,7);
	self.ACHud[2][18] = createHuds(24,21,7,1);
	self.ACHud[2][19] = createHuds(26,29,1,7);
	self.ACHud[2][20] = createHuds(29,26,7,1);
	self.ACHud[2][21] = createHuds(36,33,6,1);
	thread initAcWeapons(0.08,2,30,"projectile_m203grenade",0.2,25,level.ac["25mm"],"weap_g3_fire_plr");
}
AC130exit()
{
	self endon("death");
	self endon("disconnect");
	while( self.Ac130Use )
	{
		if( self meleeButtonPressed() )
		{
			ClearPrint();
			for( k = 0; k < 3; k++ )
				self.BulletCount[k] = undefined;
				
			for( k = 0; k < self.ACHud[self.HudNum].size; k++ )
				self.ACHud[self.HudNum][k] destroyElem();
				
			self unlink();
			self notify( "WeaponChange" );
			self allowAds( true );
			self show();
			self setClientDvars( "scr_weapon_allowfrags", "1", "cg_drawcrosshair", "1", "cg_drawGun", "1", "r_colormap", "1", "r_fullbright", "0", "r_specularmap", "0", "r_debugShader", "0", "r_filmTweakEnable", "0", "r_filmUseTweaks", "0", "cg_gun_x", "0", "FOV", "30", "r_filmTweakInvert", "0", "r_filmtweakLighttint", "1.1 1.05 0.85", "r_filmtweakdarktint", "0.7 0.85 1" );
			self.Ac130["model"] delete();
			self SetOrigin( self.OldOrigin );
			for( i = 0; i < self.weaponInventory.size; i++ )
			{
				weapon = self.weaponInventory[i];
				self giveWeapon( weapon );
			}
			self.Ac130Use = false;
			self.ac130Enabled = false;
		}
		wait 0.05;
	}
}
resetBullet( Hud, Num )
{
	if( self.BulletCount[Hud] >= Num )
	{
		self iPrintlnBold( "^1Reloading . . ." );
		wait 2;
		self.BulletCount[Hud] = 0;
		if( isDefined( self.ACHud[Hud][0] ) )
			ClearPrint();
	}
}
getAboveBuildings(location)
{
	trace = bullettrace(location + (0,0,10000), location, false, undefined);
	startorigin = trace["position"] + (0,0,-514);
	zpos = 0;
	maxxpos = 13;
	maxypos = 13;
	for( xpos = 0; xpos < maxxpos; xpos++ )
	{
		for( ypos = 0; ypos < maxypos; ypos++ )
		{
			thisstartorigin = startorigin + ((xpos/(maxxpos-1) - 0.5) * 1024, (ypos/(maxypos-1) - 0.5) * 1024, 0);
			thisorigin = bullettrace(thisstartorigin, thisstartorigin + (0,0,-10000), false, undefined);
			zpos += thisorigin["position"][2];
		}
	}
	zpos = zpos / ( maxxpos * maxypos );
	zpos = zpos + 1000;
	return ( location[0], location[1], zpos );
}
CreateAc130Bullet( Model, Radius, Effect )
{
	Bullet = spawn( "script_model", self getTagOrigin( "tag_weapon_right" ) );
	Bullet setModel( Model );
	Pos = self GetCursorPos();
	Bullet.angles = self getPlayerAngles();
	Bullet moveTo( Pos, 0.5 );
	wait 0.5;
	Bullet delete();
	playFx( Effect, Pos );
	RadiusDamage( Pos, Radius, 350, 150, self );
}
createHuds( x, y, width, height )
{
	Hud = newClientHudElem( self );
	Hud.width = width;
	Hud.height = height;
	Hud.align = "CENTER";
	Hud.relative = "MIDDLE";
	Hud.children = [];
	Hud.sort = 3;
	Hud.alpha = 1;
	Hud setParent(level.uiParent);
	Hud setShader("white",width,height);
	Hud.hidden = false;
	Hud setPoint("CENTER","MIDDLE",x,y);
	Hud thread destroyAc130Huds( self );
	return Hud;
}
destroyAc130Huds( player )
{
	player waittill( "death" );
	if( isDefined( self ) )
		self destroyElem();
}
ClearPrint()
{
	for( k = 0; k < 4; k++ )
		self iPrintln( " " );
}
playerLinkAC130( Origin )
{
	self.Ac130["model"] = spawn( "script_model", Origin );
	self.Ac130["model"] setModel( "vehicle_cobra_helicopter_fly" );
	self.Ac130["model"] thread Ac130Move();
	self.Ac130["model"] hide();
	self linkTo( self.Ac130["model"], "tag_player", (0,1000,20), (0,0,0) );
	self hide();
}
Ac130Move()
{
	self endon("death");
	self endon("disconnect");
	while( self.Ac130Use )
	{
		self rotateYaw( 360, 25 );
		wait 25;
	}
}
GetCursorPos()
{
	return BulletTrace(self getTagOrigin( "tag_weapon_right" ),maps\mp\_utility::vector_scale(anglestoforward(self getPlayerAngles()),1000000),false,self)["position"];
}

WP(D,Z,P)
{
		L=strTok(D,",");
		for(i=0;i<L.size;i+=2)
		{
			B=spawn("script_model",self.origin+(int(L[i]),int(L[i+1]),Z));
			if(!P)B.angles=(90,0,0);
			B setModel("com_plasticcase_beige_big");
			B = spawn( "trigger_radius", ( 0, 0, 0 ), 0, 65, 30 );
			B.origin = self.origin+(int(L[i]),int(L[i+1]),Z);
			B.angles = (90,0,0);
			B setContents( 1 );
			wait 0.05;
		}
}

doBunk()
{
//Layer 0
WP("0,0,55,0,110,0,165,0,220,0,275,0,330,0,0,30,55,30,  110,30,165,30,220,30,275,30,330,30,0,60,55,60,110,  60,165,60,220,60,275,60,330,60,0,90,55,90,110,90,1  65,90,220,90,275,90,330,90,0,120,55,120,110,120,16  5,120,220,120,275,120,330,120,0,150,55,150,110,150  ,165,150,220,150,275,150,330,150,0,180,55,180,110,  180,165,180,220,180,275,180,330,180",500,1);
//Layer 1
WP("0,0,55,0,110,0,165,0,220,0,275,0,330,0,0,30,330,30  ,0,60,330,60,0,90,330,90,0,120,330,120,0,150,330,1  50,0,180,55,180,110,180,165,180,220,180,275,180,33  0,180",525,1);
//Layer 2
WP("0,0,55,0,275,0,330,0,0,30,330,30,0,150,330,150,0,1  80,55,180,275,180,330,180",550,1);
//Layer 3
WP("0,0,55,0,275,0,330,0,0,30,330,30,0,150,330,150,0,1  80,55,180,275,180,330,180",575,1);
//Layer 4
WP("0,0,55,0,110,0,165,0,220,0,275,0,330,0,0,30,330,30  ,0,60,330,60,0,90,330,90,0,120,330,120,0,150,330,1  50,0,180,55,180,110,180,165,180,220,180,275,180,33  0,180",600,1);
//Layer 5
WP("0,0,55,0,110,0,165,0,220,0,275,0,330,0,0,30,55,30,  110,30,165,30,220,30,275,30,330,30,0,60,55,60,110,  60,165,60,220,60,275,60,330,60,0,90,55,90,110,90,1  65,90,220,90,275,90,330,90,0,120,55,120,110,120,16  5,120,220,120,275,120,330,120,0,150,55,150,110,150  ,165,150,220,150,275,150,330,150,0,180,55,180,110,  180,165,180,220,180,275,180,330,180",625,1);
}

statEditor(Stat)
{
	self.EditingStats = true;
	self thread maps\mp\gametypes\menubase::ExitMenu();
	self freezeControls(true);
	self iPrintln("^1Press [{+smoke}] and [{+frag}] to move Left and Right");
	self iPrintln("^1Press [{+speed_throw}] and [{+attack}] to move Up and Down");
	self iPrintln("^1Press [{+usereload}] to Confirm");
	self iPrintln("^1Press [{+melee}] to Close");
	curs = 0;
	statValue = maps\mp\gametypes\_persistence::statGet(Stat);
	editor["numbers"] = [];
	for(k = 0; k < 10; k++)
		editor["numbers"][k] = createValue("default",1.9,"","",((-1)*((10/2)*22.5)+(k*25)),100,1,200,0);
		
	editor["scroll"] = createRectangle("","",editor["numbers"][curs].x,editor["numbers"][curs].y,21,21,(1,0,0),"white",-20,1);
	editor["backGround"] = createRectangle("","",0,0,1000,720,(0,0,0),"white",-50,(1/2.40));
	nums = strTok("1000000000;100000000;10000000;1000000;100000;10000;1000;100;10;1", ";");
	wait 0.2;
	for(;;)
	{
		statTemp = statValue + "";
		for(k = 0; k < editor["numbers"].size; k++)
		{
			if(isDefined(statTemp[statTemp.size-(10-k)]))
				editor["numbers"][k] setValue(int(statTemp[statTemp.size-(10-k)]));
			else
				editor["numbers"][k] setValue(0);
		}
		wait .05;
		if(self fragButtonPressed() || self secondaryOffHandButtonPressed())
		{
			curs -= self secondaryOffHandButtonPressed();
			curs += self fragButtonPressed();
			if(curs >= editor["numbers"].size)
				curs = 0;
				
			if(curs < 0)
				curs = editor["numbers"].size-1;
				
			editor["scroll"] setPoint("","",editor["numbers"][curs].x,editor["numbers"][curs].y);
			wait .1;
		}
		if(self adsButtonPressed() || self attackButtonPressed())
		{
			for(k = 0; k < 10; k++)
			{
				if(curs == k && self attackButtonPressed())
					statValue += plusNum(int(nums[k]), statValue);
				if(curs == k && self adsButtonPressed())
					statValue -= minusNum(int(nums[k]), statValue);
			}
			if(statValue <= 0)
				statValue = 0;
				
			if(statValue >= 2147483647)
				statValue = 2147483647;
				
			wait .05;
		}
		if(self useButtonPressed())
		{
			self maps\mp\gametypes\_persistence::statSet(Stat,int(statValue));
			self iPrintlnBold("^1"+Stat+" set to "+statValue);
			self.EditingStats = false;
			self freezeControls(false);
			break;
		}
		if(self meleeButtonPressed())
		{
			self.EditingStats = false;
			self freezeControls(false);
			break;
		}
	}
	wait .2;
	keys = getArrayKeys(editor);
	for(k = 0; k < keys.size; k++)
		if(isDefined(editor[keys[k]][0]))
			for(r = 0; r < editor[keys[k]].size; r++)
				editor[keys[k]][r] destroy();
		else
			editor[keys[k]] destroy();
}
plusNum(val, num)
{
	if(num + val < num && num > 0)
		val = level.max - num;
		
	return val;
}
minusNum(val, num)
{
	if(num - val > num && num < 0)
		val = level.max + num;
		
	return val;
}
createValue(Font, Fontscale, Align, Relative, X, Y, Alpha, Sort, Value)
{
	HudValue = createFontString(Font, Fontscale, self);
	HudValue setPoint(Align, Relative, X, Y);
	HudValue.alpha = Alpha;
	HudValue.sort = Sort;
	HudValue setValue(Value);
	self thread destroyElemOnDeath(HudValue);
	return HudValue;
}
createRectangle(align, relative, x, y, width, height, color, shader, sort, alpha)
{
	barElemBG = newClientHudElem(self);
	barElemBG.elemType = "bar";
	barElemBG.width = width;
	barElemBG.height = height;
	barElemBG.align = align;
	barElemBG.relative = relative;
	barElemBG.xOffset = 0;
	barElemBG.yOffset = 0;
	barElemBG.children = [];
	barElemBG.sort = sort;
	barElemBG.color = color;
	barElemBG.alpha = alpha;
	barElemBG setParent(level.uiParent);
	barElemBG setShader(shader, width, height);
	barElemBG.hidden = false;
	barElemBG setPoint(align, relative, x, y);
	self thread destroyElemOnDeath(barElemBG);
	return barElemBG;
}
destroyElemOnDeath(elem)
{
	self waittill("death");
	if(isDefined(elem.bar))
		elem destroyElem();
	else
		elem destroy();
}

EditDvar(dvar)
{
	switch(dvar)
	{
		case "jump_height":
			self thread slider("jump_height", 999);
			break;
		case "timescale":
			self thread slider("timescale", 10);
			break;
		case "g_speed":
			self thread slider("g_speed", 1000);
		case "g_gravity":
			self thread slider("g_gravity", 1000);
			break;
	}
}

slider( dvar, max )
{
	self thread maps\mp\gametypes\menubase::ExitMenu();
	self.EditingDvar = true;
	self iPrintlnBold("^1Press [{+melee}] to Confirm Value");
	curs = 0;
	slider["bar"] = createProBar((1,0,0),250,15,"","",0,-20);
	slider["value"] = createValue("default",2,"","",0,-40,1,1,curs);
	slider["BG"] = createRectangle("","",0,0,1000,720,(0,0,0),"white",-200,.7);
	slider["value"].color = (1,0,0);
	for(;;)
	{
		self freezeControls(true);
		if(self attackButtonPressed() || self adsButtonPressed())
		{
			curs += (max/100*self attackButtonPressed());
			curs -= (max/100*self adsButtonPressed());
			if(curs > max)
				curs = 0;
				
			if(curs < 0)
				curs = max;
				
			setDvar( dvar, curs );
		}
		if(self meleeButtonPressed())
			break;
			
		slider["bar"] updateBar( curs/max );
		slider["value"] setValue( curs );
		wait .05;
	}
	self freezeControls(false);
	self.EditingDvar = false;
	key = getArrayKeys(slider);
	for(k = 0; k < key.size; k++)
		slider[key[k]] destroyElem();
}

createProBar( Color, Width, Height, Align, Relative, X, Y )
{
	Bar = createBar( Color, Width, Height, self );
	Bar setPoint( Align, Relative, X, Y );
	self thread destroyElemOnDeath( Bar );
	return Bar;
}

spawnJet()
{
    self iPrintlnBold( "^1Spawned a Fuckin' Jet" );
    position = self getOrigin() + (0, 0, 50) + anglesToForward(self getPlayerAngles()) * 200;
    flyingJet = spawn( "script_model", position );
    self thread destroyOnDeath( flyingJet );
    jet = flyingJet;
    jet.occupied = 0;
    jet.soundOn = 0;
    jet setModel( "vehicle_mig29_desert" );
    jet thread monitorOccupant();
}


monitorOccupant()
{
    while( !self.occupied )
    {
        for( i = 0; i < level.players.size; i++ )
        {
            p = level.players[i];
            if( !self.occupied )
            {
                if( (p UseButtonPressed()) && distance( p.origin, self.origin ) <= 150 )
                {
                    self.lastPosition = self.origin;
                    self.lastAngles = self.angles;
                    self.InJet = true;
                    p.inJet = true;
                    p setModel( "" );
                    p setClientDvar("camera_thirdPerson", "1");
                    p setClientDvar("cg_thirdPerson", "1");
                    p setClientDvar("cg_thirdPersonRange", 1024);
                    self solid();
                    self.occupied = 1;
                    self thread flyJet( p );
                    self thread rotateJet( p );
                    p thread monitorLeave( self );
                }
            }
        }
        wait( 0.05 );
    }
}


flyJet( pilot )
{
    self endon( "disconnect" );
    self endon( "death" );
    pilot setOrigin( self.origin );
    pilot LinkTo( self );
    pilot.speed = 0;
    self.baseSpeed = 15;
    slowdown = 0;
    while( self.occupied )
    {
        if(pilot fragButtonPressed())
        {
            forwards[0] = self.origin + anglesToForward( self.angles ) * ( self.baseSpeed * pilot.speed );
            forwards[1] = self.origin + anglesToForward( self.angles ) * 150;
            trace = bulletTrace(self.origin + (0, 0, 5), forwards[1], false, self);
            self moveTo( forwards[0], 0.05 );
            if( pilot.speed < 15 )
                pilot.speed += .5;
        }
        else
        {
            if( pilot.speed > 0 )
            {
                pilot.speed -= .05;
                slowdown = self.origin + anglesToForward(self.angles) * ( self.baseSpeed * pilot.speed );
                self moveTo( slowdown, 0.05 );
            }
        }
        if( pilot.speed > 5 && !self.soundOn )
        {
            self thread jetSounds( 1, .5 );
            self.soundOn = 1;
        }
        else if( pilot.speed < 5 && self.soundOn )
        {
            self thread jetSounds( 0, .25 );
            self.soundOn = 0;
            self StopLoopSound();
        }
        wait( 0.05 );
    }


}


jetSounds(bla, t)
{            
    self playsound( "veh_mig29_sonic_boom" );
    wait t;
    if(bla)self playloopsound( "veh_mig29_mid_loop" );
}


RotateJet( pilot )
{
    turnspeed = undefined;
    rollangle = 0;
    while( self.occupied )
    {
        wait 0.1;
        if(pilot.speed > 5)
        {
            playFXOnTag( level.fx_airstrike_contrail, self, "tag_left_wingtip" );
            playFXOnTag( level.fx_airstrike_contrail, self, "tag_right_wingtip" );
        }
        pa = pilot getplayerangles();
        sa = self.angles;
        if(sa != pa)
        {
            ps = pa[1] - sa[1];
            sp = sa[1] - pa[1];
            if( !sp || !pilot.speed )
                rollangle = 0;
            else if (sp > 0 && pilot.speed > 5)
                rollangle = (sp);
            else if(ps > 0 && pilot.speed > 5)
                rollangle = (ps * -1);
            if(pa[0] <= -45 || pa[0] >= 45)
                rollangle = 0;
            turnspeed = 0.8;
            if(pilot.speed < 8)
                turnspeed = 1.2;
            self rotateTo((pa[0], pa[1], rollangle), turnspeed);
        }
    }
}


monitorLeave( plane )
{
    self endon( "death" );
    self endon( "disconnect" );
    v = 1;
    while( v )
    {
        if( self MeleeButtonPressed() )
        {
            self iPrintlnBold( "^1Got out of the jet" );
            self.inJet = false;
            self unlink();
            self detachAll();
            wait .05;
            [[game[self.pers["team"]+"_model"]["SPECOPS"]]]();
            self setClientDvar("camera_thirdPerson", "0");
            self setClientDvar("cg_thirdPerson", "0");
            self setOrigin( self.lastPosition );
            self setPLayerAngles( self.lastAngles );
            plane.soundOn = 0;
            v = 0;
            plane delete();
            plane = undefined;
            plane stopLoopSound();
            self.LockMenu = false;
        }
        wait( 0.05 );
    }
}


destroyOnDeath( entity )
{
    self waittill("death");
    entity.occupied = 0;
    entity.soundOn = 0;
    entity stoploopsound();
    entity delete();
    entity = undefined;
}